=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2008-10-28 22:19:31 +0000
+++ bzrlib/bzrdir.py	2008-11-21 21:55:19 +0000
@@ -2646,6 +2646,11 @@
             return False
         return self.get_format_description() == other.get_format_description()
 
+    @property
+    def repository_format(self):
+        # Using a property to avoid early loading of remote
+        return remote.RemoteRepositoryFormat()
+
 
 BzrDirFormat.register_control_server_format(RemoteBzrDirFormat)
 

=== modified file 'bzrlib/repofmt/pack_repo.py'
--- bzrlib/repofmt/pack_repo.py	2008-11-17 22:40:17 +0000
+++ bzrlib/repofmt/pack_repo.py	2008-11-21 21:55:19 +0000
@@ -2296,8 +2296,10 @@
         return xml7.serializer_v7
 
     def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir(
+        matching = bzrdir.format_registry.make_bzrdir(
             '1.6.1-rich-root')
+        matching.repository_format = self
+        return matching
 
     def _ignore_setting_bzrdir(self, format):
         pass

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2008-11-13 07:11:38 +0000
+++ bzrlib/repository.py	2008-11-21 21:55:19 +0000
@@ -2241,7 +2241,12 @@
     rich_root_data = False
     supports_tree_reference = False
     supports_external_lookups = False
-    _matchingbzrdir = bzrdir.BzrDirMetaFormat1()
+
+    @property
+    def _matchingbzrdir(self):
+        matching = bzrdir.BzrDirMetaFormat1()
+        matching.repository_format = self
+        return matching
 
     def __init__(self):
         super(MetaDirRepositoryFormat, self).__init__()

=== modified file 'bzrlib/tests/per_repository/test_repository.py'
--- bzrlib/tests/per_repository/test_repository.py	2008-09-17 07:18:20 +0000
+++ bzrlib/tests/per_repository/test_repository.py	2008-11-21 21:55:19 +0000
@@ -291,6 +291,12 @@
         self.assertEqual(self.repository_format,
                          repository.RepositoryFormat.find_format(opened_control))
 
+    def test_format_matchingbzrdir(self):
+        self.assertEqual(self.repository_format,
+            self.repository_format._matchingbzrdir.repository_format)
+        self.assertEqual(self.repository_format,
+            self.bzrdir_format.repository_format)
+
     def test_create_repository(self):
         # bzrdir can construct a repository for itself.
         if not self.bzrdir_format.is_supported():

